#ifndef __CONSTANTS_H__
#define __CONSTANTS_H__


#ifdef __cplusplus
extern "C" {
#endif

extern digit_t p751[NWORDS_FIELD];
extern digit_t Montgomery_R2[NWORDS_FIELD];
extern felm_t neg_one_mont;
extern felm_t pm3over4;
extern felm_t pm1over2;
extern felm_t one_mont;
extern dfelm_t p2m1over2;
extern dfelm_t sqrt_exp;
extern felm_t two_mont;
extern felm_t two_inv_mont;
extern felm_t three_mont;
extern felm_t two_exp_372;
extern felm_t three_exp_239;
extern f2elm_t f2_four_inv_mont; 

//  these constants can easily be initialized from the others (for some definition of "easily"), and so we choose to use
//  the init_field_constants() function instead of defining them here
felm_t zero;
f2elm_t f2_one_mont;
f2elm_t f2_zero;

void init_field_constants();
                                        

#ifdef __cplusplus
}
#endif


#endif
